arch.h is gone, dmapi headers moved around a little.
[xfstests-dev.git] / tools / srcdiff
1 #!/usr/bin/perl -w
2 use strict;
3
4 # srcdiff is used to compare current user level code with the current
5 # kernel code and advise of any differences between files which are
6 # sharing some or all of their content.
7
8 # There are two classes of sharing which we will check - header files
9 # in the include directory, which must be exactly the same (use diff)
10 # and source files which contain routines which must be exactly the
11 # same (but the userland file is always a subset of the kernel file,
12 # and hence a more flexible mechanism to "diff" is required).
13
14 # NB: to cross check that srcdiff is finding all the functions in the
15 #     user source file, providing you have "mkproto" installed, you
16 #     can "cd cmd/xfsprogs/libxfs" and cut&paste this in a bourne shell:
17 #     $ for file in xfs_*.c; do
18 #     > mkproto -nps < $file | perl -ne '
19 #     > END { print "    $count\t- " }
20 #     > s/^.* (xfs\w+|\*xfs\w+|xlog\w+|\*xlog\w+) \(.*/\1/ && { $count++ }'
21 #     > echo $file
22 #     > done
23 # (compare this to "srcdiff | fgrep Total:")
24
25
26 die "WORKAREA not set" unless defined $ENV{'WORKAREA'};
27 chdir $ENV{'WORKAREA'};
28 my $xdiff = $ENV{'XDIFF'};
29 my $quiet=0;
30 my $usage=0;
31
32 foreach (@ARGV) {
33         if (/^-q$/) {
34                 $quiet++;
35         } else {
36                 print STDERR "Illegal option $_\n";
37                 $usage++;
38         }
39 }
40
41 if ($usage) {
42     print STDERR "Usage: $0 [-q]\n";
43     exit 1;
44 }
45
46 my @pkglist = qw( attr acl dmapi xfsdump xfsprogs );
47 my @difflist = qw(
48         xfs_ag.h  xfs_alloc.h  xfs_alloc_btree.h xfs_arch.h
49         xfs_attr_leaf.h  xfs_attr_sf.h  xfs_bit.h  xfs_bmap.h
50         xfs_bmap_btree.h  xfs_btree.h  xfs_buf_item.h
51         xfs_da_btree.h  xfs_dfrag.h  xfs_dinode.h  xfs_dir.h
52         xfs_dir2.h  xfs_dir2_block.h  xfs_dir2_data.h
53         xfs_dir2_leaf.h  xfs_dir2_node.h  xfs_dir2_sf.h
54         xfs_dir_leaf.h  xfs_dir_sf.h  xfs_dqblk.h  xfs_dquot_item.h
55         xfs_extfree_item.h  xfs_ialloc.h  xfs_imap.h
56         xfs_ialloc_btree.h  xfs_inode.h  xfs_inode_item.h
57         xfs_inum.h  xfs_log.h  xfs_log_priv.h  xfs_log_recover.h
58         xfs_mount.h  xfs_quota.h  xfs_rtalloc.h
59         xfs_sb.h  xfs_trans.h  xfs_trans_space.h  xfs_types.h
60         xfs_fs.h xfs_acl.h xfs_cap.h xfs_mac.h
61 );
62
63 sub straightdiff {
64         my ( $file, $prefix1, $prefix2 ) = @_;
65
66         `diff $prefix1/$file $prefix2/$file >/dev/null 2>&1`;
67         if (!$quiet) {
68                 print sprintf("\t%-35s ... ", $file);
69                 if ($? != 0)    { print "FAILED\n"; }
70                 else            { print "ok\n"; }
71         } elsif ($? != 0) { 
72                 printf("\t%-35s ... ", $file);
73                 print "FAILED\n"; 
74         }
75 }
76
77 my $first = shift @pkglist;
78 foreach (@pkglist) {
79         print "\n=== Checking $_ package ===\n";
80         straightdiff 'buildrules', "cmd/$first/include", "cmd/$_/include";
81         straightdiff 'buildmacros', "cmd/$first/include", "cmd/$_/include";
82 }
83 print "\n=== Checking headers ===\n";
84 foreach (@difflist) {
85         straightdiff $_, 'cmd/xfsprogs/include', 'linux/fs/xfs';
86 }
87 straightdiff 'dmapi_kern.h', 'cmd/dmapi/include', 'linux/fs/xfs/dmapi';
88 straightdiff 'dmapi.h', 'cmd/dmapi/include', 'linux/fs/xfs/dmapi';
89
90
91 # setstate
92 # Implements a tri-state FSA, see comments for state transitions
93 #  (knows about the way the XFS kernel code is written, & makes
94 #   some assumptions so as to not need to parse generic C code).
95 # Accepts one line at a time from a source file, picking out the
96 #   function bodies so they can be subsequently compared.
97
98
99 my $line;       # line number in current source file
100 my $state;      # current FSA state
101 my $funcbody;   # current function body (contents)
102
103 sub setstate {
104         my ( $newline ) = @_;
105         $line++;
106
107         # - state 0:
108         #       if line looks like start of a function, transition to 1
109         #               & squirrel line away as line 1 of current function
110         if ($state == 0) {
111                 if ($newline =~ m/^[xfs|xlog]/) {
112                         $state = 1;
113                         $funcbody = $newline;
114                 }
115         }
116
117         # - state 1:
118         #       if line looks like start of a function, stay here
119         #               & squirrel line away as line 1 of current function
120         #       otherwise if line isn't start of function body,
121         #               squirrel line away as next line of current function
122         #               (args/..., but not sure this is a real function yet)
123         #       otherwise (start of function)
124         #               squirrel line away as next line of current function
125         #               transition to state 2
126         elsif ($state == 1) {
127                 if ($newline =~ m/^[xfs|xlog]/) {
128                         $funcbody = $newline;
129                 }
130                 elsif ($newline =~ m/^\{/) {
131                         $state = 2;
132                         $funcbody .= $newline;
133                 }
134         }
135
136         # - state 2:
137         #       if line looks like end of function body,
138         #               squirrel line away as last line of current function
139         #               tell someone we have a complete function ready
140         #               transition to state 0
141         #       otherwise
142         #               squirrel line away as next line of current function
143         elsif ($state == 2) {
144                 $funcbody .= $newline;
145                 if ($newline =~ m/^\}/) {
146                         $state = 0;
147                         return $funcbody;
148                 }
149         }
150
151         else {
152                 die "unknown state transition";
153         }
154         return undef;   # i.e. not at end of a function
155 }
156
157 sub listfuncs {
158         my ( $file ) = @_;
159         my @funcs;
160
161         $funcbody = '';
162         $state = $line = 0;
163
164         open(USER, "$file") || die "cannot open $file";
165         while (<USER>) {
166                 my $func = setstate($_);
167                 push @funcs, $func if (defined($func)); # store function away
168         }
169         close USER;
170         return @funcs;
171 }
172
173 sub hashfuncs {
174         my ( $file ) = @_;
175         my %funcs;
176
177         $funcbody = '';
178         $state = $line = 0;
179
180         open(KERN, "$file") || die "cannot open $file";
181         while (<KERN>) {
182                 my $func = setstate($_);
183                 if (defined($func)) {
184                         $func =~ m/^([xfs|xlog]\w+)\s*\(/;
185                         next unless defined($1);
186                         my $name = $1;
187                         if (defined($func)) {
188                                 $funcs{$name} = $func;  # store function away
189                         }
190                 }
191         }
192         close KERN;
193         return %funcs;
194 }
195
196 sub diffme {
197         my ( $sa, $sb ) = @_;
198
199         return unless defined($xdiff);
200
201         open(FILEA, "> /tmp/diff.user.$$") || die "cannot write to /tmp/diff.user.$$";
202         open(FILEB, "> /tmp/diff.kern.$$") || die "cannot write to /tmp/diff.kern.$$";
203         print FILEA $sa;
204         print FILEB $sb;
205         close FILEA;
206         close FILEB;
207         `$xdiff /tmp/diff.user.$$ /tmp/diff.kern.$$`;
208         unlink ("/tmp/diff.user.$$","/tmp/diff.kern.$$");
209 }
210
211 sub functiondiff {
212         my ( $file, $prefix1, $prefix2 ) = @_;
213         my $plural = '';
214         my $count = 0;
215         my $name;
216         my $found = 0;
217
218         print "\n=== Checking $file routines ===\n" unless ($quiet);
219
220         # iterate over user funcs, match up to kernel funcs
221         # 
222         my @user = listfuncs "$prefix1/$file";
223         my %kern = hashfuncs "$prefix2/$file";
224
225         foreach my $userfunc (@user) {
226                 
227                 $userfunc =~ m/^([xfs|xlog]\w+)\s*\(/;
228                 next unless (defined($1));
229                 $name = $1;
230                 $count++;
231
232                 if (exists($kern{$name})) {
233                         if ($userfunc ne $kern{$name}) {
234                                 print "\n=== $file routines ===\n"
235                                     if (!$found++ && $quiet);
236                                     
237                                 printf("\t%-35s ... ", $name);
238                                 print "FAILED\n";
239                                 diffme $userfunc, $kern{$name};
240                         }
241                         elsif (!$quiet) {
242                                 printf("\t%-35s ... ", $name);
243                                 print "ok\n";
244                         }
245                 }
246                 else {
247                         print "Cannot find kernel function $userfunc";
248                         print " in file $prefix2/$file\n";
249                 }
250         }
251         ($count != 1) && ( $plural = 's' );
252         print "( Total: $count routine$plural checked in $file )\n" unless ($quiet);
253 }
254
255 # cmd/xfsprogs/{libxfs,libxlog}/* fs/xfs/*
256 my @funclist = qw(
257         xfs_alloc.c  xfs_alloc_btree.c  xfs_attr_leaf.c
258         xfs_bmap.c  xfs_bmap_btree.c  xfs_btree.c  xfs_da_btree.c
259         xfs_dir.c  xfs_dir2.c  xfs_dir2_block.c  xfs_dir2_data.c
260         xfs_dir2_leaf.c  xfs_dir2_node.c  xfs_dir2_sf.c
261         xfs_dir_leaf.c  xfs_ialloc.c  xfs_ialloc_btree.c
262         xfs_inode.c  xfs_rtalloc.c  xfs_mount.c  xfs_trans.c
263 );
264
265 print "\n=== Checking libxfs code ===\n";
266 foreach (@funclist) {
267         functiondiff $_, 'cmd/xfsprogs/libxfs', 'linux/fs/xfs';
268 }
269 print "\n=== Checking libxlog code ===\n";
270 functiondiff 'xfs_log_recover.c', 'cmd/xfsprogs/libxlog', 'linux/fs/xfs';